from abc import ABC, abstractmethod
from typing import List

from . import KeyEvent


class Keyboard(ABC):

    @abstractmethod
    def isKeyPressed(self, key: int) -> bool:
        raise NotImplementedError()

    @property
    @abstractmethod
    def keyEvents(self) -> List[KeyEvent]:
        raise NotImplementedError()

    @abstractmethod
    def clearKeyEvents(self):
        raise NotImplementedError()

    K_NONE = 0

    K_LEFT = 1
    K_RIGHT = 2
    K_UP = 3
    K_DOWN = 4

    K_ESCAPE = 5

    K_0 = 48
    K_1 = 49
    K_2 = 50
    K_3 = 51
    K_4 = 52
    K_5 = 53
    K_6 = 54
    K_7 = 55
    K_8 = 56
    K_9 = 57

    K_F1 = 282
    K_F2 = 283

    K_MAXCODE = 284



