from state import Region
from ..IO import IO
from ..ObjectSerializer import ObjectSerializer


class RegionSerializer(ObjectSerializer):

    def write(self, io: IO, region: Region):
        io.writeString("region")
        io.writeNumpyArray(region.cells)

    def read(self, io: IO) -> Region:
        assert io.readString() == "region"
        region = Region()
        region.cells = io.readNumpyArray()
        return region
