from state import State
from ..IO import IO
from ..ObjectSerializer import ObjectSerializer


class StateSerializer(ObjectSerializer):

    def write(self, io: IO, state: State):
        io.writeString("state")
        io.writeStringObjectDict(state.regions)

    def read(self, io: IO) -> State:
        assert io.readString() == "state"
        state = State()
        state.regions = io.readStringObjectDict()
        return state